#include <string.h>
#include <ctype.h>
#include <stdio.h>

#include "tok.h"

typedef struct { char* var,*val; } t_var; /*   SHELL -    */ 

static varn=0; // .  SHELL
static t_var *var; //  SHELL

/*   SHELL */
void printv()
{ 
 register i; 
 for(i=0; i<varn; i++) 
 printf("%s=%s\n",var[i].var,var[i].val);
}

void setvar(char* varf,char* val) //   SHELL
{
 register i;
 for(i=0; i<varn; i++)
 if(strcmp(var[i].var,varf)==0)
 {
  if(var[i].val) free(var[i].val);
  var[i].val=(char*)strdup(val);
  return;
 }
 if(varn++==0) var = (t_var*)malloc(sizeof(t_var));
 else var = (t_var*)realloc(var,varn*sizeof(t_var));
  var[varn-1].var=(char*)strdup(varf);
  var[varn-1].val=(char*)strdup(val); 
}

void unsetvar(char* varf) //   SHELL
{
 register i;
 for(i=0; i<varn; i++)
 if(strcmp(var[i].var,varf)==0)
 {
  free(var[i].var); if(var[i].val) free(var[i].val);
  if(varn>1 && i!=varn-1) var[i].val=var[varn-1].val,//   
                          var[i].var=var[varn-1].var;//   .
  varn--;  
  var = (t_var*)realloc(var,varn*sizeof(t_var));
  return;
 }
}

char* findvar(char* s) //   SHELL
{ register i; char buf[MAXARGS*20], *ss;
 for(i=0; i<varn; i++) if(strcmp(var[i].var,s)==0) return var[i].val;
 for(i=0; environ[i]; i++) 
 {
  strcpy(buf,environ[i]);
  ss=(char*)strchr(buf,'='); 
  if(ss) { *ss='\0'; if(strcmp(buf,s)==0) return ss+1; } 
 } 
 return "";
}

int enval(char* buf)//     .( )
{
 char v[MAXARGS],*s,*s1;
 if( *buf=='"' ) memmove(buf,buf+1,strlen(buf)), buf[strlen(buf)-1]='\0';
FIND: s=(char*)strchr(buf,'$'); //  '$'
 if(s) //  
 {
  *s='\0'; s++;
  strcpy(v,buf);
  if(*s=='(')
  {
   s1=(char*)strchr(s,')');
   if(s1==NULL) fprintf(stderr,"retsh:    ')'.\n"), s1="";
   else *s1++='\0';  s++;
   strcat(v,findvar(s));
   strcat(v,s1);
  }
  else strcat(v,findvar(s));
  strcpy(buf,v);
  goto FIND;
 } 
 return 0; 
}

