%{
#include "main.c.tab.h"
%}
ID [A-Za-z_0-9\!\$\%\'-\/\:-\@]+|\"[^\"]+\"
znak "-"|"+"|"/"|"*"|"^"|"%"|"("|")"|"="
SIM  "&"|"{"|"}"
%%
{znak}/(\ |\t)	return *yytext;
sin		return _sin;
cos		return _cos;
set		return _set;
unset	return _unset;
getenv	return _getenv;
setenv	return _setenv;
echo	return _echo;
exit	return _exit;
pwd		return _pwd;
cd		return _cd;
"cd.."	return _cd_;
{SIM}	return *yytext;
{ID}	{ enval(yytext); return _arg;}
[\ \t]+	;
.	fprintf(stderr,"retsh:   `%c'\n",*yytext);
%%

int yywrap(){ return 1;}
